#include <stdio.h>

int numtests;

union ld_union {
	unsigned long v[3];
	long double d;
};

union ld_union inf_div_4 = { 0x7ffd0000, 0x00000000, 0x0 };
union ld_union inf_div_2 = { 0x7ffe0000, 0x00000000, 0x0 };
union ld_union fp0;
union ld_union fp1;

#define EXPECT_FP(f, v0, v1, v2) \
	if (f.v[0] != v0 || f.v[1] != v1 || f.v[2] != v2) \
	{ \
		fprintf(stderr, "test %d: expected %08x:%08x:%08x got %08x:%08x:%08x\n", numtests, v0, v1, v2, f.v[0], f.v[1], f.v[2]); \
		status |= 1; \
	}
	
int main(void)
{
	char fail, fail2;
	int status;
	union ld_union fp0, fp1;
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tfadd.x %1,%2\n"
		"\tfmul.l #2,%1\n"
		"\tfcmp.x %1,%2\n"
		"\tfsne %0\n"
	: "=dm"(fail), "=f"(fp0.d), "=f"(fp1.d)
	: "1"(inf_div_4.d), "2"(inf_div_4.d)
	: "cc", "memory");
	if (fail)
	{
		fprintf(stderr, "test %d failed\n", numtests);
		status |= 1;
	}
	
	EXPECT_FP(fp0, 0x7ffe0000, 0x0, 0x0);
	EXPECT_FP(fp1, 0x7ffe0000, 0x0, 0x0);
	
	++numtests;
	__asm__ __volatile__(
		"\tfadd.x %1,%2\n"
		"\tfmul.l #2,%1\n"
		"\tfcmp.x %1,%2\n"
		"\tfsne %0\n"
	: "=dm"(fail), "=f"(fp0.d), "=f"(fp1.d)
	: "1"(inf_div_2.d), "2"(inf_div_2.d)
	: "cc", "memory");
	if (fail)
	{
		fprintf(stderr, "test %d failed\n", numtests);
		status |= 1;
	}
	
	EXPECT_FP(fp0, 0x7fff0000, 0x0, 0x0);
	EXPECT_FP(fp1, 0x7fff0000, 0x0, 0x0);
	
	return status;
}
